###
# PloneKeywordManager-Installer
###

from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.PloneKeywordManager import cmf_keyword_manager_globals

def install_subskin(self, out, skin_name, globals):
    skinstool=getToolByName(self, 'portal_skins')
    if skin_name not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', globals)

    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName) 
        path = [i.strip() for i in  path.split(',')]
        try:
            if skin_name not in path:
                path.insert(path.index('custom')+1, skin_name)
        except ValueError:
            if skin_name not in path:
                path.append(skin_name)  

        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)

def install(self):
    out = StringIO()
    print >>out, "Installing PloneKeywordManager."
    
    install_subskin(self, out, 'keyword_manager', cmf_keyword_manager_globals)
    print >>out, "Added skin."
    
    at=getToolByName(self, 'portal_actions')    
    if 'keywordmanager' not in [action.id for action in at.listActions()]:
        at.addAction( 'manage_keywords'
                    , 'Manage Keywords'
                    , 'string:${portal/absolute_url}/prefs_keywords_view'
                    , ''
                    , 'Modify portal content'
                    , 'user' )
    print >>out, "Added action."
    print >>out, "Done."
    
    return out.getvalue()
    